#include "owl.h"

void owl_help() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "  Keys:\n");
  strcat(buff, "    n             Move to next non-deleted message\n");
  strcat(buff, "    p             Move to previous non-deleted message\n");
  strcat(buff, "    C-n , down    Move to next message\n");
  strcat(buff, "    C-p , up      Move to previous message\n");
  strcat(buff, "    < , >         Move to first, last message\n");
  strcat(buff, "    right , left  Scroll screen left or right\n");
  strcat(buff, "    C-v           Page down\n");
  strcat(buff, "    M-v           Page up\n");
  strcat(buff, "    i             Print more information about a message\n");
  strcat(buff, "    P             Move to the next personal message\n");
  strcat(buff, "    M-P           Move to the preivous personal message\n");
  strcat(buff, "\n");
  strcat(buff, "    d             Mark message for deletion\n");
  strcat(buff, "    u             Undelete a message marked for deletion\n");
  strcat(buff, "    x             Expunge deleted messages\n");
  strcat(buff, "    T             Mark all 'trash' messages for deletion\n");
  strcat(buff, "\n");
  strcat(buff, "    z             Start a zwrite command\n");
  strcat(buff, "    r             Reply to the current message\n");
  strcat(buff, "\n");
  strcat(buff, "    A             Toggle zaway\n");
  strcat(buff, "    w             Open a URL in the message in netscape\n");
  strcat(buff, "    C-l           Refresh the screen\n");
  strcat(buff, "    C-z           Suspend\n");
  strcat(buff, "    h             Print this help message\n");
  strcat(buff, "    :             Enter command mode\n");
  strcat(buff, "\n");
  strcat(buff, "  For specific help on commands use 'help <command>'\n\n");
  strcat(buff, "  Commands:\n");
  strcat(buff, "    quit, exit    Exit owl\n");
  strcat(buff, "    zwrite        Send a zephyr\n");
  strcat(buff, "    reply         Reply to the current zephyr\n");
  strcat(buff, "    set           Set a variable\n");
  strcat(buff, "    print         Print a variables value\n");
  strcat(buff, "    zlog          Send a login or login notification\n");
  strcat(buff, "    version       Print the version number of owl\n");
  strcat(buff, "    subscribe     Subscribe to a zephyr class or instance\n");
  strcat(buff, "    unsubscribe   Unsubscribe to a zephyr class or instance\n");
  strcat(buff, "    unsuball      Unsubscribe from all zephyr classes\n");
  strcat(buff, "    getsubs       Print a list of current subscriptions\n");
  strcat(buff, "    info          Print detailed information about the current message\n");
  strcat(buff, "    help          Print the help screen\n");
  strcat(buff, "    next          Move to the next message\n");
  strcat(buff, "    prev          Move to the previous message\n");
  strcat(buff, "    next-notdel   Move to the next non-deleted message\n");
  strcat(buff, "    prev-notdel   Move to the previous non-deleted message\n");
  strcat(buff, "    expunge       Expunge messages marked for deletion\n");
  strcat(buff, "    first         Move to the first message\n");
  strcat(buff, "    last          Move to the last message\n");
  strcat(buff, "    resize        Resize owl to the size of the terminal\n");
  strcat(buff, "    suspend       Suspend owl\n");
  strcat(buff, "    exec          Run a shell command\n");
  strcat(buff, "    zaway         Turn zaway on or off, or set the message\n");
  strcat(buff, "    load-subs     Load zephyr subscriptions from a file\n");
  strcat(buff, "    about         Print information about owl\n");
  strcat(buff, "    status        Print status information about the running owl\n");
  strcat(buff, "\n");
  strcat(buff, "  Variables:\n");
  strcat(buff, "     name            settings default       meaning                                 \n");
  strcat(buff, "     --------------- -------- -------       -------                                 \n");
  strcat(buff, "     personalbell    on,off   off           ring the terminal bell when personal    \n");
  strcat(buff, "                                               messages are received                \n");
  strcat(buff, "     bell            on,off   on            enable / disable the terminal bell      \n");
  strcat(buff, "     zsigproc        <path>   -             name of a program to run that will      \n");
  strcat(buff, "                                               produce a zsigs for outgoing messages\n");
  strcat(buff, "     startuplogin    on,off   on            send a login message when owl starts    \n");
  strcat(buff, "     shutdownlogout  on,off   on            send a logout message when owl exits    \n");
  strcat(buff, "     rxping          on,off   off           display received pings                  \n");
  strcat(buff, "     txping          on,off   on            send pings                              \n");
  strcat(buff, "     displayoutgoing on,off   on            display outgoing messages               \n");
  strcat(buff, "     loginsubs       on,off   on            load logins from .anyone on startup     \n");
  strcat(buff, "     typewinsize     <int>    8             number of lines in the typing window    \n");
  strcat(buff, "     logging         on,off   off           turn personal logging on or off         \n");
  strcat(buff, "     logpath         <path>   ~/zlog/people path for logging personal zephyrs       \n");
  strcat(buff, "     classlogging    on,off   off           turn class logging on or off            \n");
  strcat(buff, "     classlogpath    <path>   ~/zlog/class  path for logging class zephyrs          \n");
  strcat(buff, "     disable-ctrl-d  on,off   off           don't send zephyrs on C-d               \n");
  strcat(buff, "\n");
  owl_function_popless_text(buff);
}

void owl_help_zlog() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    zlog - send a login or logout notification\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    zlog in\n");
  strcat(buff, "    zlog out\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    zlog in will send a login notification, zlog out will send a\n");
  strcat(buff, "    logout notification.  By default a login notification is sent\n");
  strcat(buff, "    when owl is started and a logout notification is sent when owl\n");
  strcat(buff, "    is exited.  This behavior can be changed with the 'startuplogin'\n");
  strcat(buff, "    and 'shudownlogout' variables.\n");
  owl_function_popless_text(buff);
}

void owl_help_quit() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    quit / exit - exit owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    quit\n");
  strcat(buff, "    exit\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Exit owl and run any shutdown activities.\n");
  owl_function_popless_text(buff);
}

void owl_help_zwrite() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    zwrite - send a zephyr\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    zwrite [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcde] [<user> ...] \n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Zwrite send a zephyr to the one or more users specified.\n\n");
  strcat(buff, "    The following options are available:\n\n");
  strcat(buff, "    -n    Do not send a ping message.\n\n");
  strcat(buff, "    -C    If the message is sent to more than one user include a\n");
  strcat(buff, "          \"cc:\" line in the text\n\n");
  strcat(buff, "    -c class\n");
  strcat(buff, "          Send to the specified zephyr class\n\n");
  strcat(buff, "    -i instance\n");
  strcat(buff, "          Send to the specified zephyr instance\n\n");
  strcat(buff, "    -r realm\n");
  strcat(buff, "          Send to a foreign realm\n");
  strcat(buff, "    -O opcode\n");
  strcat(buff, "          Send to the specified opcode\n");
  owl_function_popless_text(buff);
}

void owl_help_reply() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    reply - reply to the current message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    reply\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    If the current message is a personal message reply to the sender.\n");
  strcat(buff, "    If is a non-personal message reply publicly to the same\n");
  strcat(buff, "    class/instance.\n");
  owl_function_popless_text(buff);
}

void owl_help_set() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    set - set a variable value\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    set <variable> <value>\n");
  strcat(buff, "    set\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Set the named variable to the specified value.  If no arguments\n");
  strcat(buff, "    are used print the value of all variables.\n");
  owl_function_popless_text(buff);
}

void owl_help_print() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    print - print a variable value\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    print <variable>\n");
  strcat(buff, "    print\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Print the value of the named variable.  If no arugments\n");
  strcat(buff, "    are used print the value of all variables.\n");
  owl_function_popless_text(buff);
}

void owl_help_version() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    version - print the version of the running owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    version\n\n");
  owl_function_popless_text(buff);
}

void owl_help_subscribe() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    subscribe / sub - subscribe to a zephyr class, instance, recipient\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    subscribe <class> <instance> [recipient]\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Subscribe the specified class and instance.  If the recipient is\n");
  strcat(buff, "    not listed on the command line it defaults to * (the wildcard\n");
  strcat(buff, "    recipient).\n");
  owl_function_popless_text(buff);
}

void owl_help_unsubscribe() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    unsubscribe / unsub - unsubscribe from a zephyr class, instance, recipient\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    unsubscribe <class> <instance> [recipient]\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Unsubscribe from the specified class and instance.  If the recipient\n");
  strcat(buff, "    is not listed on the command line it defaults to * (the wildcard\n");
  strcat(buff, "    recipient).\n");
  owl_function_popless_text(buff);
}

void owl_help_unsuball() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    unsuball - unsubscribe from all zephyrs\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    unsuball\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Unsubscribe from all zephyrs\n");
  owl_function_popless_text(buff);
}

void owl_help_getsubs() {
  char buff[5000];

  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    getsubs - print all current subscriptions\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    getsubs\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    getsubs retrieves the current subscriptions from the server\n");
  strcat(buff, "    and displays them.\n");
  owl_function_popless_text(buff);
}

void owl_help_info() {
  char buff[5000];
    
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    info - display detailed information about the current message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    info\n\n");
  owl_function_popless_text(buff);
}

void owl_help_help() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    help - display help on using owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    help [command]\n\n");
  owl_function_popless_text(buff);
}

void owl_help_next() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    next - move the pointer to the next message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    next\n\n");
  owl_function_popless_text(buff);
}

void owl_help_prev() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    next - move the pointer to the previous message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    prev\n\n");
  owl_function_popless_text(buff);
}

void owl_help_next_notdel() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    next-notdel - move the pointer to the next non-deleted message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    next-notdel\n\n");
  owl_function_popless_text(buff);
}

void owl_help_prev_notdel() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    prev-notdel - move the pointer to the previous non-deleted message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    prev-notdel\n\n");
  owl_function_popless_text(buff);
}

void owl_help_expunge() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    expunge - remove all messages marked for deletion\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    expunge\n\n");
  owl_function_popless_text(buff);
}

void owl_help_first() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    first - move the pointer to the first message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    first\n\n");
  owl_function_popless_text(buff);
}

void owl_help_last() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    first - move the pointer to the last message\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    last\n\n");
  owl_function_popless_text(buff);
}

void owl_help_resize() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    resize - resize the window to the current screen size\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    resize\n\n");
  owl_function_popless_text(buff);
}

void owl_help_suspend() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    suspend - suspend owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    suspend\n\n");
  owl_function_popless_text(buff);
}

void owl_help_exec() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    exec - running a command from the shell\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    exec [args .. ]\n\n");
  owl_function_popless_text(buff);
}

void owl_help_zaway() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    zaway - running a command from the shell\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    zaway [ on | off ]\n");
  strcat(buff, "    zaway <message>\n\n");
  strcat(buff, "DESCRIPTION\n");
  strcat(buff, "    Turn on or off the default zaway message.  If a message is\n");
  strcat(buff, "    specified turn on zaway with that message\n");
  owl_function_popless_text(buff);
}

void owl_help_load_subs() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    load-subs - load subscriptions from a file\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    load-subs <file>\n");
  owl_function_popless_text(buff);
}


void owl_help_about() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    about - print information about owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    about\n");
  owl_function_popless_text(buff);
}

void owl_help_status() {
  char buff[5000];
  
  strcpy(buff, "OWL HELP\n\n");
  strcat(buff, "NAME\n");
  strcat(buff, "    status - print status information about the running owl\n\n");
  strcat(buff, "SYNOPSIS\n");
  strcat(buff, "    status\n");
  owl_function_popless_text(buff);
}
